// Generated by CoffeeScript 1.4.0
var cc, should;

should = require('should');

cc = require('../');

describe('ShellCommand', function() {
  it('should save log information when running', function(done) {
    var sh1;
    sh1 = new cc.ShellCommand("ls");
    return sh1.run(function() {
      should.not.exist(sh1.err);
      sh1.log.should.be.ok;
      sh1.done.should.be.ok;
      should.not.exist(sh1.alreadyDone);
      return done();
    });
  });
  it('should allow to run its command in a folder', function(done) {
    var sh1;
    sh1 = new cc.ShellCommand("ls", "lib");
    return sh1.run(function() {
      var sh2;
      sh2 = new cc.ShellCommand("ls");
      return sh2.run(function() {
        sh2.log.should.be.ok;
        sh1.log.should.be.ok;
        sh1.log.should.not.equal(sh2.log);
        return done();
      });
    });
  });
  it('should allow to overwrite the default name', function() {
    var sh1;
    sh1 = new cc.ShellCommand("ls");
    sh1.name.should.equal("ls");
    sh1.setName("ls2");
    return sh1.name.should.equal("ls2");
  });
  return it('should indicate already done if dstFile exsits', function(done) {
    var sh1;
    sh1 = new cc.ShellCommand("ls", process.cwd());
    sh1.getDstFile = function() {
      return 'package.json';
    };
    return sh1.preRun(function(really) {
      really.should.be["false"];
      sh1.done.should.be.ok;
      sh1.alreadyDone.should.be.ok;
      return done();
    });
  });
});
